unit ZitateOnline_main;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  DBGrids, DBCtrls, ZitateMsg, ZitateServer, ZitateServerDB, Zitat, ZitateDB,
  db, Anzeige, Spezial, Komplex;

type

  { TForm1 }

  TForm1 = class(TForm)
    bConnect: TButton;
    bShow: TButton;
    bSpezial: TButton;
    bKomplex: TButton;
    bSpeichern: TButton;
    bAdd: TButton;
    bAbbruch: TButton;
    Datasource1: TDatasource;
    DBGrid1: TDBGrid;
    DBMemo1: TDBMemo;
    procedure bConnectClick(Sender: TObject);
    procedure bShowClick(Sender: TObject);
    procedure bSpezialClick(Sender: TObject);
    procedure bKomplexClick(Sender: TObject);
    procedure bSpeichernClick(Sender: TObject);
    procedure bAddClick(Sender: TObject);
    procedure bAbbruchClick(Sender: TObject);
    procedure DBGrid1DblClick(Sender: TObject);
    procedure DBGrid1TitleClick(Column: TColumn);
    procedure FormCreate(Sender: TObject);
    procedure MenueDeaktivieren(Sender: TObject);
  private
    ab: boolean;
    column_letzte: integer;
  public
    { public declarations }
  end;

var
  Form1: TForm1;
  zitat2: TZitat;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.bConnectClick(Sender: TObject);
begin
   Nachricht('Versuche Verbindung zur Sprüche Datenbank');
   if not Zitadell.sucheSQLiteDatabase( 'dbTest.s3db' ) or
      not Zitadell.openSQliteDatabase
   then begin
        Nachricht('Datenbank Fehler???  Disable Menü');
        MenueDeaktivieren(Sender);
   end
   else begin
        bConnect.Enabled:= false;
        bShow.Enabled:= true;
        Nachricht('Verbindung zu SQLite hat geklappt :-)');
   end;
end;

procedure TForm1.MenueDeaktivieren(Sender: TObject);
begin
   bConnect.Enabled:=false;
   bShow.Enabled:=false;
   bSpezial.Enabled:=false;
   bKomplex.Enabled:=false;
end;

procedure TForm1.bShowClick(Sender: TObject);
begin
   DataSource1.DataSet:= zitateDB1.getZitateSetUpdate;
   DBGrid1.Columns[0].Visible:= false;
   DBMemo1.DataField := 'SPRUCH';
   bSpezial.Enabled:= true;
   bKomplex.Enabled:= true;
end;

procedure TForm1.bSpezialClick(Sender: TObject);
begin
   Form5.ID:=Datasource1.DataSet.FieldByName('ID').asInteger;
   DataSource1.Dataset.DisableControls; //nur nötig wegen der Commits
   Form5.ShowModal;
   DataSource1.Dataset.EnableControls;  //nur nötig wegen der Commits
   bShowClick(Sender);                  //nur nötig wegen der Commits
end;

procedure TForm1.bKomplexClick(Sender: TObject);
begin
   Form4.ID:=Datasource1.DataSet.FieldByName('ID').asInteger;
   Form4.ShowModal;
end;

procedure TForm1.bSpeichernClick(Sender: TObject);
begin
   ZitateDB1.SpeichernSatz(Sender);
end;

procedure TForm1.bAddClick(Sender: TObject);
begin
   ZitateDB1.AddSatz(Sender);
end;

procedure TForm1.bAbbruchClick(Sender: TObject);
begin
   ZitateDB1.AbbruchSatz(Sender);
end;

procedure TForm1.DBGrid1DblClick(Sender: TObject);
begin
   Form2.ID:=Datasource1.DataSet.FieldByName('ID').asInteger;
   Form2.ShowModal;
   ShowMessage(Datasource1.DataSet.FieldByName('Spruch').asString);
end;

procedure TForm1.DBGrid1TitleClick(Column: TColumn);
begin
   if Column.Index = column_letzte
      then ab:= not ab
      else ab:= false;
   column_letzte:= Column.Index;
   DataSource1.DataSet:= zitateDB1.getZitateSetSortiert(Column.index, ab);
   DBGrid1.Columns[0].Visible:= false;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
   ab:= false;
   column_letzte:= -1;
end;

end.
